//+------------------------------------------------------------------+
//|                                             Gann_time_peakUP.mq4 |
//|                                                 George Tischenko |
//|                       |
//+------------------------------------------------------------------+
#property copyright "George Tischenko"
//              0     1     2     3      4      5      6      7      8      9      10       
string T[11]={"TH45","TH60","TH90","TH120","TH135","TH180","TH225","TH240","TH270","TH300","TH360"}; // 
int nil[6]={2,3,5,7,8,10}; //Number of Important Level -    ( )
double ang[11]={0.25,0.333,0.5,0.667,0.75,1.0,1.25,1.333,1.5,1.75,2.0}; // ""  9
color CLR[4]={Blue,Red,Navy,Black}; //  
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
  int i,count_VL;  
  
  if(ObjectFind("K_peakUP")==-1) CreateLable("K_peakUP","k =",5);
  if(ObjectFind("val_K_peakUP")==-1) CreateLable("val_K_peakUP","1",50);
  if(ObjectFind("TL_peakUP")==-1) CreateTL("TL_peakUP",Time[0],Time[20],(2*High[0])-Low[0],CLR[3]); 
  
  for(i=10;i>=0;i--)
    {
    color clr=CLR[0];
    if(ObjectFind(T[i])==-1) 
      {
      for(int k=0;k<6;k++)
        {
        if(i==nil[k])
          {
          clr=CLR[1];
          break;
          }
        }      
      CreateVL(T[i],0,clr);
      count_VL++;
      }
    }  
  if(count_VL>0) return(0);  
//----
  int t1=ObjectGet("TL_peakUP",OBJPROP_TIME1);
  int t2=ObjectGet("TL_peakUP",OBJPROP_TIME2);
  double tsq1=NormalizeDouble(MathSqrt(t1),10);
  double tsq2=NormalizeDouble(MathSqrt(t2),10);
  double inc=MathAbs(tsq2-tsq1);  //   ,  180    9
//----
  double t_start;
  if(t1<t2) t_start=MathSqrt(t2); //     
  else t_start=MathSqrt(t1); //     
//----
  t_start=NormalizeDouble(t_start,10);
  double t_lvl;
  double K_ang=NormalizeDouble(StrToDouble(ObjectDescription("val_K_peakUP")),0); 
  if(inc>0)
    { 
    for(i=0;i<11;i++)
      {
      t_lvl=MathPow(t_start+(inc*ang[i]*K_ang),2);
      t_lvl=NormalizeDouble(t_lvl,0);
      ObjectSet(T[i],OBJPROP_TIME1,t_lvl);
      }
    }
//----
  return(0);
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void CreateTL(string name,int time1,int time2,double price,color clr)
  {
//----
  ObjectCreate(name,OBJ_TREND,0,time1,price,time2,price);
  ObjectSet(name,OBJPROP_WIDTH,2);
  ObjectSet(name,OBJPROP_STYLE,0);
  ObjectSet(name,OBJPROP_COLOR,clr);
  ObjectSet(name,OBJPROP_RAY,false);
//---
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void CreateVL(string name,int nb,color clr)
  {
//----
  ObjectCreate(name,OBJ_VLINE,0,Time[nb],0);
  ObjectSet(name,OBJPROP_WIDTH,1);
  ObjectSet(name,OBJPROP_STYLE,1);
  ObjectSet(name,OBJPROP_COLOR,clr);
  ObjectSet(name,OBJPROP_BACK,true);
//---
  }
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void CreateLable(string name,string txt,int x)
  {
//----
  ObjectCreate(name,OBJ_LABEL,0,0,0);
  ObjectSet(name,OBJPROP_CORNER,2);
  ObjectSet(name,OBJPROP_XDISTANCE,x);
  ObjectSet(name,OBJPROP_YDISTANCE,60);
  ObjectSetText(name,txt,15,"Arial Black",CLR[2]);
//----
  }  
//+------------------------------------------------------------------+